// 20200403 Modified by Marek Olszewski for browsing devices sucha a cellphone

// Demo of the new features of the TREE control
// by Dr. Claudio Soto (November 2013)

#include "directry.ch"
#include "hmg.ch"

PROCEDURE Main

#define _ID_INI_  0
#define FOF_SIMPLEPROGRESS   0x0100a
	
#DEFINE IMAGE_FOLDER_UNCHECKED 0
#DEFINE IMAGE_FOLDER_CHECKED 4

#DEFINE IMAGE_DOCUMENT_UNCHECKED 2
#DEFINE IMAGE_DOCUMENT_CHECKED 5

	PUBLIC nItemID := NIL
	public aDevices := {}
	public aSelectedFiles := {}
	public aSelected := {}

	SET FONT TO "Tahoma", 9

	DEFINE WINDOW Form_1; 
      AT 0 , 0; 
      WIDTH 1000 HEIGHT 650; 
      TITLE "Scan and copy files from device";
      MAIN; 
      NOMAXIMIZE; 
      NOSIZE

	DEFINE STATUSBAR
		STATUSITEM ""
	END STATUSBAR

   	@ 15, 10 LABEL L_SelectDevice VALUE "Select device to scan" HEIGHT 18
	@ 5, 150 BUTTON SearchDevices  CAPTION "Search for &devices" ACTION  GetDeviceList() WIDTH 120 HEIGHT 24
  
	DEFINE TREE TREE_COMPUTER ;
		AT 35, 10; 
		WIDTH 260; 
		HEIGHT 500; 
		VALUE 0 ;
		ITEMIDS ;
		ON DBLCLICK SelectDevice(This.Value);
		ON CHANGE SelectDevice(This.Value)
	END TREE
	
	// status label of processed directory
    @ 560, 10 LABEL Label_ProcessedObject VALUE "Processed object" WIDTH 1000

    @ 5,285 FRAME Frame_1  WIDTH 440  HEIGHT 105
	@ 10, 295 LABEL Label_1 VALUE "Source" HEIGHT 18
	@ 30, 295 TEXTBOX TextBoxPATH  WIDTH 200  HEIGHT 24  VALUE GetMyDocumentsFolder()

	@ 60, 295 LABEL Label_2 VALUE "File mask" HEIGHT 18
	@ 80, 295 TEXTBOX Text_1  WIDTH 120  HEIGHT 24  VALUE "*.*"

	@ 80, 430 CHECKBOX Check_1 CAPTION "Include hidden folders and files"  WIDTH 190  HEIGHT 24  VALUE .T.

	@ 30, 620 BUTTON ButtonScan  CAPTION "&Scan for files and folders" ACTION  BuildTree() BOLD WIDTH 90 HEIGHT 40 MULTILINE
  
	  
	DEFINE TREE Tree_1; 
		 AT 115, 285; 
		 WIDTH 440 HEIGHT 250;
		 NODEIMAGES { "folder.bmp", "folder.bmp" };
		 ITEMIMAGES { "documents.bmp", "documents.bmp" };
		 ON DBLCLICK ChangeSelection(This.Value);
		 ON CHANGE ShowItemInfo() ;
		 ITEMIDS		
	END TREE

	Form_1.Tree_1.TextColor := RED
	Form_1.Tree_1.BackColor := WHITE
	Form_1.Tree_1.LineColor := NAVY


	@ 380, 285 FRAME FrameSort CAPTION "Sort Options" WIDTH  440 HEIGHT 100

	@ 400, 310 CHECKBOX CheckSort1 CAPTION "Recuesive(Sub-folders)" WIDTH 150 VALUE .T.
	@ 425, 310 CHECKBOX CheckSort2 CAPTION "CaseSensitive"          WIDTH 150 VALUE .F.
	@ 450, 310 CHECKBOX CheckSort3 CAPTION "Ascending Order"        WIDTH 150 VALUE .T.

	@ 400, 470 RADIOGROUP RadioGroupSort OPTIONS {"Nodes First","Nodes Last","Nodes Mix"} VALUE 3 TRANSPARENT  WIDTH 80

	@ 425, 600 BUTTON ButtonSort  CAPTION "Sort"  ACTION Proc_Sort () WIDTH 80

	@ 520, 330 CHECKBOX CheckExpand CAPTION "Expand/Collapse Recursive (Sub-folders)"  WIDTH 240  HEIGHT 24  VALUE .T.

	@ 490, 330 BUTTON ButtonExpand    CAPTION "Expand"    ACTION  Proc_Expand ()
	@ 490, 505 BUTTON ButtonCollapse  CAPTION "Collapse"  ACTION  Form_1.Tree_1.Collapse ( Form_1.Tree_1.Value , Form_1.CheckExpand.Value )


    @ 5,740 FRAME Frame_Target  WIDTH 250  HEIGHT 105
	@ 10, 745 BUTTON BUTTON_GetTarget CAPTION "Select destination folder" ACTION  GetDestinationFolder() HEIGHT 28 WIDTH 160
	@ 40, 745 TEXTBOX TextBoxDestinationFolder  WIDTH 240  HEIGHT 24  VALUE "d:\temp\"	//"--- select destination folder ---"
	
	@ 70, 825 BUTTON BUTTON_CopyFiles CAPTION "Copy selected files" ACTION  CopyFiles() HEIGHT 28 WIDTH 160
      
   END WINDOW
  
   CENTER WINDOW Form_1
   
	// fill computer tree with values
	GetDeviceList()
	
	Form_1.Tree_1.AddImage := "folder_checked.bmp"
	Form_1.Tree_1.AddImage := "documents_checked.bmp"
	
	ON KEY ESCAPE OF FORM_1 ACTION FORM_1.RELEASE
	
   ACTIVATE WINDOW Form_1

RETURN

 //MsgInfo ({" Value          = ",Form_1.Tree_1.Value, HB_OsNewLine(),;
             //                      " Item           = ",Form_1.Tree_1.Item (Form_1.Tree_1.Value), HB_OsNewLine(),;
             //                      " IsTrueNode     = ",Form_1.Tree_1.IsTrueNode (Form_1.Tree_1.Value), HB_OsNewLine(),; 
             //                      " FlagNode       = ",Form_1.Tree_1.NodeFlag (Form_1.Tree_1.Value), HB_OsNewLine(),; 
             //                      " ImageIndex     = ",HB_VALTOEXP(Form_1.Tree_1.ImageIndex (Form_1.Tree_1.Value)), HB_OsNewLine(),;
             //                      " RootValue      = ",Form_1.Tree_1.RootValue, HB_OsNewLine(),;
             //                      " FirstItemValue = ",Form_1.Tree_1.FirstItemValue, HB_OsNewLine(),;
             //                      " ParentValue    = ",Form_1.Tree_1.ParentValue(Form_1.Tree_1.Value), HB_OsNewLine(), HB_OsNewLine(),;
             //                      " ChildValues    = ",HB_VALTOEXP(Form_1.Tree_1.ChildValue (Form_1.Tree_1.Value)), HB_OsNewLine(), HB_OsNewLine(),;
             //                      " ChildText      = ",HB_VALTOEXP(Form_1.Tree_1.ItemText(Form_1.Tree_1.ChildValue (Form_1.Tree_1.Value))), HB_OsNewLine(), HB_OsNewLine(),;
             //                      " SiblingValues  = ",HB_VALTOEXP(Form_1.Tree_1.SiblingValue (Form_1.Tree_1.Value)), HB_OsNewLine(), HB_OsNewLine(),;
             //                      " SiblingText    = ",HB_VALTOEXP(Form_1.Tree_1.ItemText(Form_1.Tree_1.SiblingValue (Form_1.Tree_1.Value)))});
             

*********************************************************
PROCEDURE EnableButtons ( lEnabled )
*********************************************************
   Form_1.ButtonScan.Enabled        := lEnabled
   Form_1.ButtonSort.Enabled        := lEnabled
   Form_1.ButtonExpand.Enabled      := lEnabled
   Form_1.ButtonCollapse.Enabled    := lEnabled
RETURN


*********************************************************
PROCEDURE Proc_Sort
*********************************************************
LOCAL aNodePosition := { TREESORTNODE_FIRST, TREESORTNODE_LAST, TREESORTNODE_MIX }   // Constants defined in file: \include\i_tree.ch
   IF Form_1.Tree_1.ItemCount > 0
      WaitWindow("Wait...", .T.)
      Form_1.Tree_1.DisableUpdate

      TREESORT Tree_1 OF Form_1 ; 
          ITEM           Form_1.Tree_1.Value ; 
          RECURSIVE      Form_1.CheckSort1.Value ;
          CASESENSITIVE  Form_1.CheckSort2.Value ;
          ASCENDINGORDER Form_1.CheckSort3.Value ;
          NODEPOSITION   aNodePosition [ Form_1.RadioGroupSort.Value ]

   // Form_1.Tree_1.Sort ( Form_1.Tree_1.Value, Form_1.CheckSort1.Value, Form_1.CheckSort2.Value, Form_1.CheckSort3.Value, aNodePosition [Form_1.RadioGroupSort.Value] )

      Form_1.Tree_1.EnableUpdate
      WaitWindow()
   ENDIF
RETURN


*********************************************************
PROCEDURE Proc_Expand
*********************************************************
   IF Form_1.Tree_1.ItemCount > 0
      WaitWindow("Wait...", .T.)
      Form_1.Tree_1.DisableUpdate 
      Form_1.Tree_1.Expand ( Form_1.Tree_1.Value , Form_1.CheckExpand.Value ) 
      Form_1.Tree_1.EnableUpdate
      WaitWindow()
   ENDIF
RETURN

*_---------------------------------
FUNCTION GetDeviceList()

	LOCAL oShell, oFolder, oItems, oItem
	LOCAL cName
	LOCAL i, iMax


	Form_1.Tree_COMPUTER.DeleteAllItems
	oShell := CreateObject( "shell.application" )

	IF NIL <> oShell
		oFolder := oShell:NameSpace( CSIDL_DRIVES )                     // 0x0011 // My Computer
		IF NIL <> oFolder
			oItems := oFolder:Items()
			iMax := oItems:Count
			aDevices := {}
			FOR i := 1 TO iMax
				oItem := oItems:Item( i - 1 )
				IF !EMPTY( oItem )
					aAdd(aDevices, oItem)
					cName := UPPER( oItem:name )
					// add item to tree
					Form_1.TREE_COMPUTER.AddItem(cName,0, len(aDevices))
				ENDIF
			NEXT i
		ENDIF
	ENDIF
	
RETURN
*--------------------
function SelectDevice
	param nDeviceItem
	if nDeviceItem>0
		Form_1.TextBoxPATH.Value := aDevices[nDeviceItem]:name
	endif
return
*-----------------------------
PROCEDURE BuildTree

LOCAL   cPath := Form_1.TextBoxPATH.Value
local oDevice
local cCaption := ""
PRIVATE lBreak := .F.

   cCaption := Form_1.ButtonScan.Caption
   Form_1.ButtonScan.Caption := "Press Esc Stop"
   EnableButtons ( .F. )
   
	ON KEY ESCAPE OF Form_1 ACTION lBreak := MsgYesNo( "Stop Scan?", "Confirm action")

	IF .NOT.( EMPTY( cPath ) )

		Form_1.Tree_1.DeleteAllItems
		Form_1.Tree_1.DisableUpdate
		nItemID := _ID_INI_
      
		DEFINE NODE cPath  IMAGES NIL  ID nItemID
			nItemID++
			nDevice := Form_1.TREE_Computer.Value
			oDevice := aDevices[nDevice]
			ScanDevice( oDevice, 0, Form_1.TextBoxPATH.Value )
			// reset all selections
			aSelectFiles := {}
		END NODE
      
		Form_1.Tree_1.Expand ( Form_1.Tree_1.RootValue )
		Form_1.Tree_1.EnableUpdate

		Form_1.StatusBar.Item( 1 ) := HB_NTOS (Form_1.Tree_1.ItemCount) + " files/folders"
		Form_1.Tree_1.Value := Form_1.Tree_1.FirstItemValue // Form_1.Tree_1.RootValue
		Form_1.Tree_1.SetFocus

	ENDIF

	RELEASE KEY ESCAPE OF Form_1
	
	ON KEY ESCAPE OF FORM_1 ACTION FORM_1.RELEASE
	
   Form_1.ButtonScan.Caption     := cCaption
   EnableButtons ( .T. )
RETURN


****************************************************************
PROCEDURE ScanDevice(oDevice, nParent, cParent)
****************************************************************
*
* this function searches directories and files on device
*
****************************************************************

	local cMask     := AllTrim( Form_1.Text_1.Value )
	local cAttr     := IIF ( Form_1.Check_1.Value, "H", "" )
	local i, aDir, aFiles, xItem
	local iMax
	local cMax
	local oStorageFile := NIL
	local oStorageFolder := NIL
	local cCaption := ""
	private lBreak := .F.

	oStorageFolder := oDevice:GetFolder:items
	
	IF EMPTY( oStorageFolder )
		return
	endif

	cCaption := Form_1.ButtonScan.Caption
	Form_1.ButtonScan.Caption := "Press Esc Stop"
	EnableButtons ( .F. )
    
	WAIT WINDOW "Scanning device... be patient" NOWAIT
	SetProperty("_HMG_CHILDWAITWINDOW","Height", 100)
	SetProperty("_HMG_CHILDWAITWINDOW","Message","Height", 90)

	ON KEY ESCAPE OF Form_1 ACTION lBreak := MsgYesNo( "Stop Scan?", "Confirm action")
	  
	BEGIN SEQUENCE
	  
		iMax := oStorageFolder:Count
		cMax := " of "+HB_NTOS(iMax) + " | "
	  // directories first
	  	FOR i = 1 TO iMax
			oStorageFile := oStorageFolder:Item( i - 1 )
			if !empty(oStorageFile)
				if oStorageFile:IsFolder
					Form_1.Label_ProcessedObject.Value := HB_NTOS(i) + cMax + cParent + "/" + oStorageFile:name
					nItemID++
					Form_1.Tree_1.AddItem( oStorageFile:name, nParent, nItemID)
					// mark this node as true node, even it empty
					Form_1.Tree_1.NodeFlag(nItemID) := .T.
					Form_1.Tree_1.CARGO(nItemID) := { .T., oStorageFile:Path, oStorageFile:Size, oStorageFile:Type}
					Form_1.Tree_1.ImageIndex ( nItemID ) := { IMAGE_FOLDER_UNCHECKED, IMAGE_FOLDER_UNCHECKED }
					ScanDevice( oStorageFile, nItemID, oStorageFile:name )
				endif
			endif
		next i

		// and now, rest of files
	 
		FOR i = 1 TO iMax
			oStorageFile := oStorageFolder:Item( i - 1 )
			if !empty( oStorageFile )
				Form_1.Label_ProcessedObject.Value := str(i,6) + cMax+ cParent + "/" + oStorageFile:name
				xItem := {oStorageFile:name }
	
				// abandon links
				if oStorageFile:IsLink
					loop
				endif
				//abandon directories
				if oStorageFile:IsFolder
					loop
				endif
				nItemID++
				Form_1.Tree_1.AddItem( oStorageFile:name, nParent, nItemID)
				Form_1.Tree_1.CARGO(nItemID) := { .F., oStorageFile:Path, oStorageFile:Size, oStorageFile:Type, oStorageFile}	// FILE
				Form_1.Tree_1.ImageIndex ( nItemID ) := { IMAGE_DOCUMENT_UNCHECKED, IMAGE_DOCUMENT_UNCHECKED }
				
			endif
		next i
		
         DO EVENTS
         IF lBreak == .T.
            BREAK
         ENDIF 
	
	END SEQUENCE
	
	oStorageFile := NIL
	oStorageFolder := NIL
	
	RELEASE KEY ESCAPE OF Form_1
	ON KEY ESCAPE OF FORM_1 ACTION FORM_1.RELEASE

	Form_1.ButtonScan.Caption     := cCaption
	WAIT CLEAR
	EnableButtons ( .T. )
 
RETURN

*--------------------

function DebugMSG
	local i, aTemp := {}
	local cTemp := ""
	
	cTemp := "Point of CALL: "+ ProcName(1)+"(" + alltrim(str(ProcLine(1)))+")" + chr(10)
	for i := 1 to pcount()
		aadd( aTemp, hb_PValue(i))
		cTemp += "TYP:" +valtype(hb_PValue(i))+" ->"+hb_valtoexp(hb_PValue(i)) + "<-"+chr(10)
	next i
	msgbox(cTemp, "Debug information" )
 return
*-----------------
function ShowItemInfo
	local nValue
	nValue := this.Value
	if nValue > 0
		Form_1.Label_ProcessedObject.Value := hb_valtoexp(Form_1.Tree_1.Cargo(nValue))
	endif
return
*-----------------
function ChangeSelection(nValue)
	
	local c
	local i
	local aChildList := {}
	local lSelect := .t.
	if nValue == 0
		return
	endif
	
	Form_1.Tree_1.DisableUpdate
	
	i := aScan(aSelectedFiles, nValue)
	lSelect := (i==0)
	
	if Form_1.Tree_1.CARGO(nValue)[1]	// this item points directory
		Form_1.Tree_1.ImageIndex ( nValue ) := if(lSelect, { IMAGE_FOLDER_CHECKED, IMAGE_FOLDER_CHECKED }, { IMAGE_FOLDER_UNCHECKED, IMAGE_FOLDER_UNCHECKED } )
	else
		Form_1.Tree_1.ImageIndex ( nValue ) := if(lSelect, { IMAGE_DOCUMENT_CHECKED, IMAGE_DOCUMENT_CHECKED }, { IMAGE_DOCUMENT_UNCHECKED, IMAGE_DOCUMENT_UNCHECKED })
	endif
	
	if lSelect
		aAdd(aSelectedFiles, nValue)
	else
		hb_adel(aSelectedFiles, i, .t.)
	endif
		
	// if directory - proceed its children
	if Form_1.Tree_1.CARGO(nValue)[1]	// this item point directory
		SelectChildren(nValue, lSelect)
	endif
	
	// this section prevets to collapsing, expanding tree after double clicking by mouse 
	// Warning - it does not work after ENTER key
	Form_1.Tree_1.DisableUpdate 
	if !Form_1.Tree_1.IsExpand(nValue)
		Form_1.Tree_1.Expand ( nValue , Form_1.CheckExpand.Value ) 
	else
		Form_1.Tree_1.Collapse ( nValue , Form_1.CheckExpand.Value )
	endif
	
	Form_1.Tree_1.EnableUpdate
return
*---------
function SelectChildren(nValue, lSelect)

	local aChildList := {}
	local c
	local p
	local nChild
	
	aChildList :=Form_1.Tree_1.ChildValue (nValue)
	
	if empty(aChildList)
		return
	else
		for c:=1 to len(aChildList)
			nChild := aChildList[c]
			// select/deselect this items and its children
			if Form_1.Tree_1.CARGO(nChild)[1]	// this item point directory
				Form_1.Tree_1.ImageIndex ( nChild ) := if(lSelect, { IMAGE_FOLDER_CHECKED, IMAGE_FOLDER_CHECKED }, { IMAGE_FOLDER_UNCHECKED, IMAGE_FOLDER_UNCHECKED } )
				// only directories have childs
				SelectChildren(nChild, lSelect)
			else
				Form_1.Tree_1.ImageIndex ( nChild ) := if(lSelect, { IMAGE_DOCUMENT_CHECKED, IMAGE_DOCUMENT_CHECKED }, { IMAGE_DOCUMENT_UNCHECKED, IMAGE_DOCUMENT_UNCHECKED })
			endif
			// test if node/item already selected
			p := aScan(aSelectedFiles, nChild)
			
			if lSelect
				if p==0
					// new selection
					aAdd(aSelectedFiles, nChild)
				endif
			else
				// remove selection
				if p>0
					hb_aDel(aSelectedFiles, p, .T.)
				endif
			endif
		next c
	endif
return
*------------------
function GetDestinationFolder
	
	local cFolder 
	
	cFolder := GetFolder()
	if !empty( cFolder )
		if !right(cFolder) == "\"
			cFolder+= "\"
		endif
		Form_1.TextBoxDestinationFolder.Value := cFolder
	endif
return !empty( cFolder )
*---------------------
function CopyFiles
	local cDestFolder
	local oDestFolder 
	local oShell
	local i
	local p
	local cFileName := ""
	local cDestFileName := ""
	local xFlag   := FOF_SIMPLEPROGRESS
	local oFile, xCount, nCount
	local nSkip := 0
	
	do while .t.
		cDestFolder := alltrim(Form_1.TextBoxDestinationFolder.Value)
		if !file(cDestFolder+"nul")
			if !GetDestinationFolder()
				MsgStop("Copying abandoned!")
				return .f.
			endif
		else
			exit
		endif
	enddo
	
	oShell := CreateObject( "Shell.Application" )
	oDestFolder := oShell:NameSpace( cDestFolder )
	
	SetProperty("_HMG_CHILDWAITWINDOW","Height", 110)
	SetProperty("_HMG_CHILDWAITWINDOW","Width", 400)
	SetProperty("_HMG_CHILDWAITWINDOW","Message","Width", 380)
	SetProperty("_HMG_CHILDWAITWINDOW","Message","Height", 90)
	SetProperty("_HMG_CHILDWAITWINDOW","Message","row", 10)
	SetProperty("_HMG_CHILDWAITWINDOW","Message","Col", 10)
	
	WAIT WINDOW "copying files..." NOWAIT
	

	for i:=1 to len(aSelectedFiles)
		nValue := aSelectedFiles[i]
		// for now, i'm copying without folder structures
		if Form_1.Tree_1.Cargo(nValue)[1] == .F.
			// this is file
			cFileName := Form_1.Tree_1.Cargo(nValue)[2]
			SetProperty("_HMG_CHILDWAITWINDOW","Message","Value", "copying files..."+chr(10)+cFileName)
			p := rat("\", cFileName)
			if p>0
				cDestFileName := substr(cFileName, p+1)
			else
				cDestFileName := cFileName
			endif
			
			//FileCopy(cFileName, cDestFolder+cDestFileName)
			
			// I don't know why it doesn't work
			oFile := Form_1.Tree_1.Cargo(nValue)[5]
			oDestFolder:CopyHere( oFile, xFlag )

			// wait until all files are written
			xCount := 0
			do while .T.
				// compare if file is written
				nCount := oDestFolder:items() :Count()
				if nCount + nSkip >= i
					exit
				endif
				sleep( 10 )
				xCount ++
				IF xCount > 50
					exit
				endif
			enddo
		endif
	next i
	
	WAIT CLEAR
	
	oShell := NIL
	oDestFolder := NIL
	
 return